Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/src/Ifetch_unit_allocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/src/Ifetch_unit_allocation.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/src/Ifetch_unit_allocation.cpp	(revision 88)
@@ -57,11 +57,11 @@
     // ~~~~~[ Interface "icache_req" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     {
-      ALLOC_INTERFACE("icache_req",OUT, WEST, "Instruction cache request.");
+      ALLOC_INTERFACE("icache_req",OUT, WEST, _("Instruction cache request."));
 
       ALLOC_VALACK_OUT(out_ICACHE_REQ_VAL      ,VAL);
       ALLOC_VALACK_IN ( in_ICACHE_REQ_ACK      ,ACK);
     //ALLOC_SIGNAL_OUT(out_ICACHE_REQ_THREAD_ID,"thread_id",Tcontext_t           ,_param->_size_context_id );
-      ALLOC_SIGNAL_OUT(out_ICACHE_REQ_PACKET_ID,"packet_id",Tpacket_t            ,_param->_size_queue_ptr  );
-      ALLOC_SIGNAL_OUT(out_ICACHE_REQ_ADDRESS  ,"address"  ,Ticache_instruction_t,_param->_size_address    );
+      ALLOC_SIGNAL_OUT(out_ICACHE_REQ_PACKET_ID,"packet_id",Tpacket_t            ,_param->_size_ifetch_queue_ptr  );
+      ALLOC_SIGNAL_OUT(out_ICACHE_REQ_ADDRESS  ,"address"  ,Ticache_instruction_t,_param->_size_instruction_address    );
       ALLOC_SIGNAL_OUT(out_ICACHE_REQ_TYPE     ,"type"     ,Ticache_type_t       ,_param->_size_icache_type);
     }
@@ -69,14 +69,14 @@
     // ~~~~~[ Interface "icache_rsp" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     {
-      ALLOC_INTERFACE("icache_rsp",IN , WEST, "Instruction cache respons.");
+      ALLOC_INTERFACE("icache_rsp",IN , WEST, _("Instruction cache respons."));
 
       ALLOC_VALACK_IN  ( in_ICACHE_RSP_VAL        ,VAL);
       ALLOC_VALACK_OUT (out_ICACHE_RSP_ACK        ,ACK);
     //ALLOC_SIGNAL_IN  ( in_ICACHE_RSP_THREAD_ID  ,"thread_id"  ,Tcontext_t           ,_param->_size_context_id  );
-      ALLOC_SIGNAL_IN  ( in_ICACHE_RSP_PACKET_ID  ,"packet_id"  ,Tpacket_t            ,_param->_size_queue_ptr   );
+      ALLOC_SIGNAL_IN  ( in_ICACHE_RSP_PACKET_ID  ,"packet_id"  ,Tpacket_t            ,_param->_size_ifetch_queue_ptr   );
       ALLOC_SIGNAL_IN  ( in_ICACHE_RSP_ERROR      ,"error"      ,Ticache_error_t      ,_param->_size_icache_error);
     }
     {
-      ALLOC1_INTERFACE("icache_rsp",IN , WEST, "Instruction cache respons.",_param->_nb_instruction);
+      ALLOC1_INTERFACE("icache_rsp",IN , WEST, _("Instruction cache respons."),_param->_nb_instruction);
 
       ALLOC1_SIGNAL_IN ( in_ICACHE_RSP_INSTRUCTION,"instruction",Ticache_instruction_t,_param->_size_instruction );
@@ -85,19 +85,19 @@
     // ~~~~~[ Interface : "predict" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     {
-      ALLOC_INTERFACE("predict",OUT, NORTH, "Acces Instruction cache respons.");
+      ALLOC_INTERFACE("predict",OUT, NORTH, _("Predict the next pc."));
 
       ALLOC_VALACK_OUT (out_PREDICT_VAL                        ,VAL);
       ALLOC_VALACK_IN  ( in_PREDICT_ACK                        ,ACK);
-      ALLOC_SIGNAL_OUT (out_PREDICT_PC_PREVIOUS                ,"pc_previous"                ,Tgeneral_address_t,_param->_size_address);
-      ALLOC_SIGNAL_OUT (out_PREDICT_PC_CURRENT                 ,"pc_current"                 ,Tgeneral_address_t,_param->_size_address);
+      ALLOC_SIGNAL_OUT (out_PREDICT_PC_PREVIOUS                ,"pc_previous"                ,Tgeneral_address_t,_param->_size_instruction_address);
+      ALLOC_SIGNAL_OUT (out_PREDICT_PC_CURRENT                 ,"pc_current"                 ,Tgeneral_address_t,_param->_size_instruction_address);
       ALLOC_SIGNAL_OUT (out_PREDICT_PC_CURRENT_IS_DS_TAKE      ,"pc_current_is_ds_take"      ,Tcontrol_t        ,1);
-      ALLOC_SIGNAL_IN  ( in_PREDICT_PC_NEXT                    ,"pc_next"                    ,Tgeneral_address_t,_param->_size_address);
+      ALLOC_SIGNAL_IN  ( in_PREDICT_PC_NEXT                    ,"pc_next"                    ,Tgeneral_address_t,_param->_size_instruction_address);
       ALLOC_SIGNAL_IN  ( in_PREDICT_PC_NEXT_IS_DS_TAKE         ,"pc_next_is_ds_take"         ,Tcontrol_t        ,1);
-      ALLOC_SIGNAL_IN  ( in_PREDICT_INST_IFETCH_PTR            ,"inst_ifetch_ptr"            ,Tinst_ifetch_ptr_t,_param->_size_instruction_ptr);
+      ALLOC_SIGNAL_IN  ( in_PREDICT_INST_IFETCH_PTR            ,"inst_ifetch_ptr"            ,Tinst_ifetch_ptr_t,_param->_size_inst_ifetch_ptr);
       ALLOC_SIGNAL_IN  ( in_PREDICT_BRANCH_STATE               ,"branch_state"               ,Tbranch_state_t   ,_param->_size_branch_state);
-      ALLOC_SIGNAL_IN  ( in_PREDICT_BRANCH_UPDATE_PREDICTION_ID,"branch_update_prediction_id",Tprediction_ptr_t ,_param->_size_branch_update_prediction);
-    }
-    {
-      ALLOC1_INTERFACE("predict",IN , NORTH, "Acces Instruction cache respons.",_param->_nb_instruction);
+      ALLOC_SIGNAL_IN  ( in_PREDICT_BRANCH_UPDATE_PREDICTION_ID,"branch_update_prediction_id",Tprediction_ptr_t ,_param->_size_depth);
+    }
+    {
+      ALLOC1_INTERFACE("predict",IN , NORTH, _("Predict the next pc."),_param->_nb_instruction);
 
       ALLOC1_SIGNAL_IN ( in_PREDICT_INSTRUCTION_ENABLE         ,"instruction_enable"         ,Tcontrol_t        ,1);
@@ -106,15 +106,15 @@
     // ~~~~~[ Interface : "decod" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     {
-      ALLOC_INTERFACE("decod",OUT , EAST, "Send bundle to the decod unit.");
+      ALLOC_INTERFACE("decod",OUT , EAST, _("Send bundle to the decod unit."));
 
     //ALLOC_SIGNAL_OUT (out_DECOD_CONTEXT_ID                 ,"context_id"                 ,Tcontext_t        ,_param->_size_context_id);
-      ALLOC_SIGNAL_OUT (out_DECOD_ADDRESS                    ,"address"                    ,Tgeneral_address_t,_param->_size_address);
-      ALLOC_SIGNAL_OUT (out_DECOD_INST_IFETCH_PTR            ,"inst_ifetch_ptr"            ,Tinst_ifetch_ptr_t,_param->_size_instruction_ptr);
+      ALLOC_SIGNAL_OUT (out_DECOD_ADDRESS                    ,"address"                    ,Tgeneral_address_t,_param->_size_instruction_address);
+      ALLOC_SIGNAL_OUT (out_DECOD_INST_IFETCH_PTR            ,"inst_ifetch_ptr"            ,Tinst_ifetch_ptr_t,_param->_size_inst_ifetch_ptr);
       ALLOC_SIGNAL_OUT (out_DECOD_BRANCH_STATE               ,"branch_state"               ,Tbranch_state_t   ,_param->_size_branch_state);
-      ALLOC_SIGNAL_OUT (out_DECOD_BRANCH_UPDATE_PREDICTION_ID,"branch_update_prediction_id",Tprediction_ptr_t ,_param->_size_branch_update_prediction);
+      ALLOC_SIGNAL_OUT (out_DECOD_BRANCH_UPDATE_PREDICTION_ID,"branch_update_prediction_id",Tprediction_ptr_t ,_param->_size_depth);
       ALLOC_SIGNAL_OUT (out_DECOD_EXCEPTION                  ,"exception"                  ,Texception_t      ,_param->_size_exception_ifetch);
     }
     {
-      ALLOC1_INTERFACE("decod",OUT , EAST, "Send bundle to the decod unit.",_param->_nb_instruction);
+      ALLOC1_INTERFACE("decod",OUT , EAST, _("Send bundle to the decod unit."),_param->_nb_instruction);
 
       ALLOC1_VALACK_OUT(out_DECOD_VAL                        ,VAL);
@@ -125,9 +125,12 @@
     // ~~~~~[ Interface "event" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     {
-      ALLOC_INTERFACE("event",IN , NORTH, "Event interface.");
-
-      ALLOC_VALACK_IN ( in_EVENT_VAL    ,VAL);
-      ALLOC_VALACK_OUT(out_EVENT_ACK    ,ACK);
-      ALLOC_SIGNAL_IN ( in_EVENT_ADDRESS,"address",Tgeneral_address_t,_param->_size_address);
+      ALLOC_INTERFACE("event",IN , NORTH, _("Event interface."));
+
+      ALLOC_VALACK_IN ( in_EVENT_VAL              ,VAL);
+      ALLOC_VALACK_OUT(out_EVENT_ACK              ,ACK);
+      ALLOC_SIGNAL_IN ( in_EVENT_ADDRESS          ,"address"         ,Tgeneral_address_t,_param->_size_instruction_address);
+      ALLOC_SIGNAL_IN ( in_EVENT_ADDRESS_NEXT     ,"address_next"    ,Tgeneral_address_t,_param->_size_instruction_address);
+      ALLOC_SIGNAL_IN ( in_EVENT_ADDRESS_NEXT_VAL ,"address_next_val",Tcontrol_t,1);
+      ALLOC_SIGNAL_IN ( in_EVENT_IS_DS_TAKE       ,"is_ds_take"      ,Tcontrol_t,1);
     }
     
@@ -137,5 +140,5 @@
     {
       name = _name+"_address_management";
-      std::cout << "Create   : " << name << std::endl;
+      log_printf(Ifetch_unit,Core,FUNCTION,_("Create   : %s"),name.c_str());
       
       _component_address_management = new morpheo::behavioural::core::multi_front_end::front_end::ifetch_unit::address_management::Address_management
@@ -156,5 +159,5 @@
     {
       name = _name+"_ifetch_queue";
-      std::cout << "Create   : " << name << std::endl;
+      log_printf(Ifetch_unit,Core,FUNCTION,_("Create   : %s"),name.c_str());
       
       _component_ifetch_queue = new morpheo::behavioural::core::multi_front_end::front_end::ifetch_unit::ifetch_queue::Ifetch_queue
@@ -175,5 +178,5 @@
     {
       name = _name+"_ifetch_unit_glue";
-      std::cout << "Create   : " << name << std::endl;
+      log_printf(Ifetch_unit,Core,FUNCTION,_("Create   : %s"),name.c_str());
       
       _component_ifetch_unit_glue = new morpheo::behavioural::core::multi_front_end::front_end::ifetch_unit::ifetch_unit_glue::Ifetch_unit_Glue
@@ -200,5 +203,5 @@
     {
       src = _name+"_address_management";
-      std::cout << "Instance : " << src << std::endl;
+      log_printf(INFO,Core,FUNCTION,_("Instance : %s"),src.c_str());
 	   
       {
@@ -225,10 +228,10 @@
 	  }
 
-	if (_param->_have_port_instruction_ptr)
+	if (_param->_have_port_inst_ifetch_ptr)
 	COMPONENT_MAP(_component,src ,"out_ADDRESS_INST_IFETCH_PTR"            ,
 		                 dest, "in_ADDRESS_INST_IFETCH_PTR"            );
 	COMPONENT_MAP(_component,src ,"out_ADDRESS_BRANCH_STATE"               ,
 		                 dest, "in_ADDRESS_BRANCH_STATE"               );
-	if (_param->_have_port_branch_update_prediction_id)
+	if (_param->_have_port_depth)
 	COMPONENT_MAP(_component,src ,"out_ADDRESS_BRANCH_UPDATE_PREDICTION_ID",
 		                 dest, "in_ADDRESS_BRANCH_UPDATE_PREDICTION_ID");
@@ -281,10 +284,10 @@
 	PORT_MAP(_component,src , "in_PREDICT_PC_NEXT_IS_DS_TAKE"         
 		           ,dest, "in_PREDICT_PC_NEXT_IS_DS_TAKE"         );
-	if (_param->_have_port_instruction_ptr)
+	if (_param->_have_port_inst_ifetch_ptr)
 	PORT_MAP(_component,src , "in_PREDICT_INST_IFETCH_PTR"            
 		           ,dest, "in_PREDICT_INST_IFETCH_PTR"            );
 	PORT_MAP(_component,src , "in_PREDICT_BRANCH_STATE"               
 		           ,dest, "in_PREDICT_BRANCH_STATE"               );
-	if (_param->_have_port_branch_update_prediction_id)
+	if (_param->_have_port_depth)
 	PORT_MAP(_component,src , "in_PREDICT_BRANCH_UPDATE_PREDICTION_ID"
 		           ,dest, "in_PREDICT_BRANCH_UPDATE_PREDICTION_ID");
@@ -306,5 +309,8 @@
 
 	dest = _name;
-	PORT_MAP(_component,src , "in_EVENT_ADDRESS",dest, "in_EVENT_ADDRESS");
+	PORT_MAP(_component,src , "in_EVENT_ADDRESS"         ,dest , "in_EVENT_ADDRESS"          );
+	PORT_MAP(_component,src , "in_EVENT_ADDRESS_NEXT"    ,dest , "in_EVENT_ADDRESS_NEXT"     );
+	PORT_MAP(_component,src , "in_EVENT_ADDRESS_NEXT_VAL",dest , "in_EVENT_ADDRESS_NEXT_VAL" );
+	PORT_MAP(_component,src , "in_EVENT_IS_DS_TAKE"      ,dest , "in_EVENT_IS_DS_TAKE"       );
       }
     }
@@ -315,5 +321,5 @@
     {
       src = _name+"_ifetch_queue";
-      std::cout << "Instance : " << src << std::endl;
+      log_printf(INFO,Core,FUNCTION,_("Instance : %s"),src.c_str());
 	   
       {
@@ -335,5 +341,5 @@
 #endif
 
-	if (_param->_have_port_queue_ptr)
+	if (_param->_have_port_ifetch_queue_ptr)
 	PORT_MAP(_component,src ,"out_ADDRESS_IFETCH_QUEUE_ID"            ,
 		            dest,"out_ICACHE_REQ_PACKET_ID"               );
@@ -386,8 +392,8 @@
 
 	PORT_MAP(_component,src ,"out_DECOD_ADDRESS"                    ,dest,"out_DECOD_ADDRESS"                    );
-	if (_param->_have_port_instruction_ptr)
+	if (_param->_have_port_inst_ifetch_ptr)
 	PORT_MAP(_component,src ,"out_DECOD_INST_IFETCH_PTR"            ,dest,"out_DECOD_INST_IFETCH_PTR"            );
 	PORT_MAP(_component,src ,"out_DECOD_BRANCH_STATE"               ,dest,"out_DECOD_BRANCH_STATE"               );
-	if (_param->_have_port_branch_update_prediction_id)
+	if (_param->_have_port_depth)
 	PORT_MAP(_component,src ,"out_DECOD_BRANCH_UPDATE_PREDICTION_ID",dest,"out_DECOD_BRANCH_UPDATE_PREDICTION_ID");
 	PORT_MAP(_component,src ,"out_DECOD_EXCEPTION"                  ,dest,"out_DECOD_EXCEPTION"                  );
@@ -404,5 +410,5 @@
 	PORT_MAP(_component,src , "in_ICACHE_RSP_VAL"      ,dest, "in_ICACHE_RSP_VAL"      );
 	PORT_MAP(_component,src ,"out_ICACHE_RSP_ACK"      ,dest,"out_ICACHE_RSP_ACK"      );
-	if (_param->_have_port_queue_ptr)
+	if (_param->_have_port_ifetch_queue_ptr)
 	PORT_MAP(_component,src , "in_ICACHE_RSP_PACKET_ID",dest, "in_ICACHE_RSP_PACKET_ID");
 	PORT_MAP(_component,src , "in_ICACHE_RSP_ERROR"    ,dest, "in_ICACHE_RSP_ERROR"    );
@@ -437,5 +443,5 @@
     {
       src = _name+"_ifetch_unit_glue";
-      std::cout << "Instance : " << src << std::endl;
+      log_printf(INFO,Core,FUNCTION,_("Instance : %s"),src.c_str());
 	   
       {
@@ -490,9 +496,11 @@
 
     // ~~~~~[ Others ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
-    if (DEBUG_Ifetch_unit == true)
-      _component->test_map();
-
-#ifdef POSITION
-    _component->generate_file();
+#if DEBUG_Ifetch_unit == true
+    _component->test_map();
+#endif
+    
+#ifdef POSITION
+    if (usage_is_set(_usage,USE_POSITION))
+      _component->generate_file();
 #endif
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/src/Ifetch_unit_deallocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/src/Ifetch_unit_deallocation.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/src/Ifetch_unit_deallocation.cpp	(revision 88)
@@ -22,5 +22,5 @@
     log_printf(FUNC,Ifetch_unit,FUNCTION,"Begin");
 
-    if (_usage & USE_SYSTEMC)
+    if (usage_is_set(_usage,USE_SYSTEMC))
       {
 	delete     in_CLOCK ;
@@ -30,5 +30,5 @@
 	delete     in_ICACHE_REQ_ACK                      ;
       //delete    out_ICACHE_REQ_THREAD_ID                ;
-	if (_param->_have_port_queue_ptr)
+	if (_param->_have_port_ifetch_queue_ptr)
 	delete    out_ICACHE_REQ_PACKET_ID                ;
 	delete    out_ICACHE_REQ_ADDRESS                  ;
@@ -38,5 +38,5 @@
 	delete    out_ICACHE_RSP_ACK                      ;
       //delete     in_ICACHE_RSP_THREAD_ID                ;
-	if (_param->_have_port_queue_ptr)
+	if (_param->_have_port_ifetch_queue_ptr)
         delete     in_ICACHE_RSP_PACKET_ID                ;
 	delete []  in_ICACHE_RSP_INSTRUCTION              ;
@@ -51,8 +51,8 @@
 	delete     in_PREDICT_PC_NEXT_IS_DS_TAKE          ;
 	delete []  in_PREDICT_INSTRUCTION_ENABLE          ;
-	if (_param->_have_port_instruction_ptr)
+	if (_param->_have_port_inst_ifetch_ptr)
 	delete     in_PREDICT_INST_IFETCH_PTR             ;
 	delete     in_PREDICT_BRANCH_STATE                ;
-	if (_param->_have_port_branch_update_prediction_id)
+	if (_param->_have_port_depth)
 	delete     in_PREDICT_BRANCH_UPDATE_PREDICTION_ID ;
 
@@ -62,8 +62,8 @@
       //delete    out_DECOD_CONTEXT_ID                    ;
 	delete    out_DECOD_ADDRESS                       ;
-	if (_param->_have_port_instruction_ptr)
+	if (_param->_have_port_inst_ifetch_ptr)
 	delete    out_DECOD_INST_IFETCH_PTR               ;
 	delete    out_DECOD_BRANCH_STATE                  ;
-	if (_param->_have_port_branch_update_prediction_id)
+	if (_param->_have_port_depth)
 	delete    out_DECOD_BRANCH_UPDATE_PREDICTION_ID   ;
 	delete    out_DECOD_EXCEPTION                     ;
@@ -72,4 +72,7 @@
 	delete    out_EVENT_ACK                           ;
 	delete     in_EVENT_ADDRESS                       ;
+	delete     in_EVENT_ADDRESS_NEXT                  ;
+	delete     in_EVENT_ADDRESS_NEXT_VAL              ;
+	delete     in_EVENT_IS_DS_TAKE                    ;
       }
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/src/Ifetch_unit_end_cycle.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/src/Ifetch_unit_end_cycle.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/src/Ifetch_unit_end_cycle.cpp	(revision 88)
@@ -24,5 +24,6 @@
 
 #ifdef STATISTICS
-    _stat->end_cycle();
+    if (usage_is_set(_usage,USE_STATISTICS))
+      _stat->end_cycle();
 #endif    
 
@@ -30,5 +31,6 @@
     // Evaluation before read the ouput signal
 //  sc_start(0);
-    _interfaces->testbench();
+    if (usage_is_set(_usage,USE_VHDL_TESTBENCH))
+      _interfaces->testbench();
 #endif
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/src/Parameters.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/src/Parameters.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/src/Parameters.cpp	(revision 88)
@@ -21,5 +21,7 @@
 			  uint32_t nb_instruction               ,
 			  uint32_t size_branch_update_prediction,
-			  uint32_t size_address                 )
+			  uint32_t size_address                 ,
+                          bool     is_toplevel
+                          )
   {
     log_printf(FUNC,Ifetch_unit,FUNCTION,"Begin");
@@ -27,13 +29,6 @@
     _size_queue                            = size_queue                   ;
     _nb_instruction                        = nb_instruction               ;
-    _size_branch_update_prediction         = size_branch_update_prediction;
-    _size_address                          = size_address                 ;
-
-    _size_queue_ptr                        = log2(size_queue);
-    _size_instruction_ptr                  = log2(nb_instruction);
-
-    _have_port_queue_ptr                   = _size_queue_ptr > 0;
-    _have_port_instruction_ptr             = _size_instruction_ptr > 0;
-    _have_port_branch_update_prediction_id = size_branch_update_prediction > 0;
+//  _size_branch_update_prediction         = size_branch_update_prediction;
+//  _size_address                          = size_address                 ;
 
     test();
@@ -50,5 +45,19 @@
     _param_ifetch_unit_glue   = new morpheo::behavioural::core::multi_front_end::front_end::ifetch_unit::ifetch_unit_glue::  Parameters
       (size_address);
-    
+
+    if (is_toplevel)
+      {
+        _size_instruction_address   = size_address;
+        _size_ifetch_queue_ptr      = log2(size_queue);
+        _size_inst_ifetch_ptr       = log2(nb_instruction);
+        _size_depth                 = size_branch_update_prediction;
+
+        _have_port_ifetch_queue_ptr = _size_ifetch_queue_ptr > 0;
+        _have_port_inst_ifetch_ptr  = _size_inst_ifetch_ptr > 0;
+        _have_port_depth            = _size_depth > 0;
+
+        copy ();
+      }
+
     log_printf(FUNC,Ifetch_unit,FUNCTION,"End");
   };
@@ -74,4 +83,17 @@
   };
 
+#undef  FUNCTION
+#define FUNCTION "Ifetch_unit::copy"
+  void Parameters::copy (void) 
+  {
+    log_printf(FUNC,Ifetch_unit,FUNCTION,"Begin");
+    
+    COPY(_param_address_management);
+    COPY(_param_ifetch_queue      );
+    COPY(_param_ifetch_unit_glue  );
+
+    log_printf(FUNC,Ifetch_unit,FUNCTION,"End");
+  };
+
 }; // end namespace ifetch_unit
 }; // end namespace front_end
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/src/Parameters_print.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/src/Parameters_print.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/src/Parameters_print.cpp	(revision 88)
@@ -23,16 +23,21 @@
     log_printf(FUNC,Ifetch_unit,FUNCTION,"Begin");
 
-    XML xml ("ifetch_unit");
+//     XML xml ("ifetch_unit");
 
-    xml.balise_open("ifetch_unit");
-    xml.singleton_begin("size_queue                   "); xml.attribut("value",toString(_size_queue                   )); xml.singleton_end();
-    xml.singleton_begin("nb_instruction               "); xml.attribut("value",toString(_nb_instruction               )); xml.singleton_end();
-    xml.singleton_begin("size_branch_update_prediction"); xml.attribut("value",toString(_size_branch_update_prediction)); xml.singleton_end();
-    xml.singleton_begin("size_address                 "); xml.attribut("value",toString(_size_address                 )); xml.singleton_end();
-    xml.balise_close();
+//     xml.balise_open("ifetch_unit");
+//     xml.singleton_begin("size_queue                   "); xml.attribut("value",toString(_size_queue                   )); xml.singleton_end();
+//     xml.singleton_begin("nb_instruction               "); xml.attribut("value",toString(_nb_instruction               )); xml.singleton_end();
+// //  xml.singleton_begin("size_branch_update_prediction"); xml.attribut("value",toString(_size_branch_update_prediction)); xml.singleton_end();
+// //  xml.singleton_begin("size_address                 "); xml.attribut("value",toString(_size_address                 )); xml.singleton_end();
+//     xml.balise_close();
+
+//     return xml.get_body(depth);
+
+    std::string str = "";
 
     log_printf(FUNC,Ifetch_unit,FUNCTION,"End");
+
+    return str;
     
-    return xml.get_body(depth);
   };
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Makefile	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Makefile	(revision 88)
@@ -0,0 +1,24 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT			= ./
+include				$(DIR_COMPONENT)/Makefile.defs
+
+#-----[ Library ]------------------------------------------
+LIBRARY				= $(DIR_LIB)/libFront_end.a
+
+
+#-----[ include ]------------------------------------------
+
+all				:
+				@$(MAKE) all_component
+
+include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Component
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Makefile.defs
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Makefile.defs	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Makefile.defs	(revision 88)
@@ -0,0 +1,11 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT_MORPHEO		= ../../../..
+DIR_MORPHEO			= $(DIR_COMPONENT)/$(DIR_COMPONENT_MORPHEO)
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Makefile.deps
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Makefile.deps	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Makefile.deps	(revision 88)
@@ -0,0 +1,73 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+# DIR_MORPHEO must be defined
+
+Front_end			= yes
+
+ifndef Behavioural
+include 			$(DIR_MORPHEO)/Behavioural/Makefile.deps
+endif
+ifndef Ifetch_unit
+include 			$(DIR_MORPHEO)/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Makefile.deps
+endif
+ifndef Prediction_unit
+include 			$(DIR_MORPHEO)/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Makefile.deps
+endif
+ifndef Decod_unit
+include 			$(DIR_MORPHEO)/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Makefile.deps
+endif
+ifndef Context_State
+include 			$(DIR_MORPHEO)/Behavioural/Core/Multi_Front_end/Front_end/Context_State/Makefile.deps
+endif
+ifndef Front_end_Glue
+include 			$(DIR_MORPHEO)/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/Makefile.deps
+endif
+
+#-----[ Directory ]----------------------------------------
+
+Front_end_DIR			=	$(DIR_MORPHEO)/Behavioural/Core/Multi_Front_end/Front_end
+
+#-----[ Library ]------------------------------------------
+
+Front_end_LIBRARY		= 	-lFront_end                     \
+					$(Ifetch_unit_LIBRARY)          \
+					$(Prediction_unit_LIBRARY)      \
+					$(Decod_unit_LIBRARY)           \
+					$(Context_State_LIBRARY)        \
+					$(Front_end_Glue_LIBRARY)       \
+					$(Behavioural_LIBRARY)	
+
+Front_end_DIR_LIBRARY		=	-L$(Front_end_DIR)/lib          \
+					$(Ifetch_unit_DIR_LIBRARY)      \
+					$(Prediction_unit_DIR_LIBRARY)  \
+					$(Decod_unit_DIR_LIBRARY)       \
+					$(Context_State_DIR_LIBRARY)    \
+					$(Front_end_Glue_DIR_LIBRARY)   \
+					$(Behavioural_DIR_LIBRARY)
+
+#-----[ Rules ]--------------------------------------------
+
+Front_end_library		:
+				@\
+				$(MAKE) Behavioural_library;		\
+				$(MAKE) Ifetch_unit_library;		\
+				$(MAKE) Prediction_unit_library;	\
+				$(MAKE) Decod_unit_library;		\
+				$(MAKE) Context_State_library;		\
+				$(MAKE) Front_end_Glue_library;		\
+				$(MAKE) --directory=$(Front_end_DIR) --makefile=Makefile;
+
+Front_end_library_clean	:
+				@\
+				$(MAKE) Behavioural_library_clean;	\
+				$(MAKE) Ifetch_unit_library_clean;	\
+				$(MAKE) Prediction_unit_library_clean;	\
+				$(MAKE) Decod_unit_library_clean;	\
+				$(MAKE) Context_State_library_clean;	\
+				$(MAKE) Front_end_Glue_library_clean;	\
+				$(MAKE) --directory=$(Front_end_DIR) --makefile=Makefile clean;
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Glue/SelfTest/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Glue/SelfTest/Makefile	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Glue/SelfTest/Makefile	(revision 88)
@@ -24,4 +24,6 @@
 library_clean			: Branch_Target_Buffer_Glue_library_clean
 
+local_clean			:
+
 include                         $(DIR_COMPONENT)/Makefile.deps
 include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Glue/SelfTest/src/main.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Glue/SelfTest/src/main.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Glue/SelfTest/src/main.cpp	(revision 88)
@@ -55,5 +55,7 @@
 	 _nb_inst_predict    ,
 	 _nb_inst_decod      ,
-	 _nb_inst_update     );
+	 _nb_inst_update     ,
+         true // is_toplevel
+         );
       
       msg(_("%s"),param->print(1).c_str());
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Glue/SelfTest/src/test.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Glue/SelfTest/src/test.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Glue/SelfTest/src/test.cpp	(revision 88)
@@ -23,4 +23,14 @@
 #endif
 
+  Tusage_t _usage = USE_ALL;
+
+//   _usage = usage_unset(_usage,USE_SYSTEMC              );
+//   _usage = usage_unset(_usage,USE_VHDL                 );
+//   _usage = usage_unset(_usage,USE_VHDL_TESTBENCH       );
+//   _usage = usage_unset(_usage,USE_VHDL_TESTBENCH_ASSERT);
+//   _usage = usage_unset(_usage,USE_POSITION             );
+//   _usage = usage_unset(_usage,USE_STATISTICS           );
+//   _usage = usage_unset(_usage,USE_INFORMATION          );
+
   Branch_Target_Buffer_Glue * _Branch_Target_Buffer_Glue = new Branch_Target_Buffer_Glue 
     (name.c_str(),
@@ -29,5 +39,5 @@
 #endif
      _param,
-     USE_ALL);
+     _usage);
   
 #ifdef SYSTEMC
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Glue/include/Parameters.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Glue/include/Parameters.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Glue/include/Parameters.h	(revision 88)
@@ -29,5 +29,5 @@
   public : uint32_t   _size_buffer       ;
   public : uint32_t   _associativity     ;
-  public : uint32_t   _size_address      ;
+//public : uint32_t   _size_address      ;
   public : uint32_t   _nb_inst_predict   ;
   public : uint32_t   _nb_inst_decod     ;
@@ -51,7 +51,11 @@
 			uint32_t   nb_inst_predict   ,
 			uint32_t   nb_inst_decod     ,
-			uint32_t   nb_inst_update    );
+			uint32_t   nb_inst_update    ,
+                        bool       is_toplevel=false
+                        );
 //   public : Parameters  (Parameters & param) ;
   public : ~Parameters () ;
+
+  public :        void            copy       (void);
 
   public :        Parameters_test msg_error  (void);
